; intellect.lsp

(load "jpnslisp.lsp")

(setq *max-key-number* 0)

(defun intellect ()
    (let ((brain (make-hash-table)) (word))
	(princ "Intellect version1.00 rr") (terpri)
	(load-data brain)
	(set-max-key-number brain)
	(princ "IɂbyeƓ") (terpri)
	(loop
;(princ *max-key-number*) (princ brain) (terpri)
	    (princ '{ŒP͂ĉ:)
	    (setq word (read-line))
	    (if (string-equal word "bye") (return))
	    (main word brain)
        )
	(princ "ۑ܂(y/n)")
	(if (eql (read) 'y) (save-data brain))
    )
)

(defun save-data (brain)
    (let ((f (open "intellectdata.txt" :direction :output)))
	(if (null f) (progn (princ "t@CJ܂") (terpri))
	    (progn
		(princ "ۑDDD") (terpri)
		(maphash
		    #'(lambda (key v)
			(print `(,key ,v) f) ) brain)
		(close f)
		(princ "ۑ܂") (terpri) ) ) ) )

(defun set-max-key-number (brain)
    (maphash #'(lambda (x y) (if (< *max-key-number* x) (setq *max-key-number* x))) brain) )

(defun load-data (brain)
    (let ((one) (f (open "intellectdata.txt")))
	(if (null f) (progn (princ "t@CJ܂") (terpri))
	    (progn
		(princ "ǂݍݒDDD") (terpri)
		(loop
	    	    (if (eql (setq one (read f nil t)) t) (return))
	    	    (setf (gethash (car one) brain) (cadr one)) )
		(close f)
		(princ "ǂݍ݂܂") (terpri) ) ) ) )

(defun question (word brain)
    (prog (shape color)
	(princ word) (princ "̌`́H") (setq shape (read-line)) (if (string-equal shape "bye") (return))
	(princ word) (princ "̐F́H") (setq color (read-line)) (if (string-equal color "bye") (return))
	(setf (gethash (setq *max-key-number* (1+ *max-key-number*)) brain)
			(cons (cons "O" (cons word nil)) `(("`" ,shape) ("F" ,color))))
    )
)

(defun main (word brain)
    (if (exist-word word brain) (name-info) (question word brain))
)

(defun name-info ()
    (let ((temp *mem*) (name))
	(setq name (assoc-string "O" temp))
	(if (not (null name)) (setq name (cadr name)))
	(loop
	    (if (null temp) (return))
	    (if (not (eql (caar temp) "O"))
		(progn (princ name) (princ "") (princ (caar temp)) (princ "")
			(princ (cadar temp)) (princ "łB") (terpri) ) )
	    (setq temp (cdr temp)) ) ) )

(defun exist-word (word brain)
    (setq *flag* nil)
    (maphash
	#'(lambda (x y)
	    (let ((a y))
		(loop
		    (if (null a) (return))
	            (if (and (string-equal (caar a) "O") (string-equal (cadar a) word))
			(progn (setq *mem* y) (setq *flag* x) (return)) )
		    (setq a (cdr a)) ) ) )
	brain )
    (if *flag* t nil) )

(defun assoc-string (x alist)
    (cond
	((atom alist) nil)
	((string-equal x (car (car alist))) (car alist))
	(t (assoc x (cdr alist))) ) )

(intellect)
